/*
 * $Id: pllolcode.h,v 1.10 2007/10/13 23:20:52 eggyknap Exp $
 */

#ifndef PLLOLCODE_H
#define PLOLCODE_H

#include "pllolcode_lang.h"
#include "postgres.h"

typedef enum { node_CMDBLOCK, node_VISIBLE, node_YARN, node_NUMBR, node_NUMBAR, node_TROOF, node_FOUNDYR, node_IDENT } NodeType;

typedef union {
		int numbrVal;
		float numbarVal;
		char *yarnVal;
	} NodeVal;

typedef struct lolNode lolNode;

typedef struct lolNodeList {
	int length;
	lolNode *head;
	lolNode *tail;
} lolNodeList;	

struct lolNode {
	NodeType node_type;
	struct node_struct *next;
	/* list for sub-nodes */
	lolNodeList *list;
	NodeVal nodeVal;
};

/* Symbol table related stuff */

typedef enum { ident_YARN, ident_NUMBR, ident_NUMBAR, ident_TROOF } IdentType;

typedef struct lolIdent {
	char *name;
	IdentType type;
	NodeVal value;
} lolIdent;

typedef enum { lolFAIL, lolWIN } lolTroof;

extern lolIdent *returnVal;

void lolSetVar(char *name, IdentType type, NodeVal value);
lolIdent *lolGetVar(char *name);
void lolInitVars(void);
char *lolVarGetString(lolIdent *var);
float lolVarGetNumbar(lolIdent *var);
int lolVarGetNumbr(lolIdent *var);
lolTroof lolVarGetTroof(lolIdent *var);

extern lolIdent *IT;

extern char *scanbuf;
extern int scanbuflen;
char stringbuf[255];
extern char *pllolcode_yytext;

extern lolNodeList *lolListAppend(lolNodeList *list, lolNode *node);
extern lolNodeList *lolMakeList(lolNode *node);
#endif
